#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>

#include " BoardSign.h "


typedef int    (_stdcall*GetErrorMessage)(int errorCode, char* errorMsg);
typedef int    (_stdcall*GetDeviceInfo)(DEVICE_INFO* info);
typedef int    (_stdcall*GetDeviceStatus)();
typedef int    (_stdcall*RegisterDeviceStatusCallBack)(DEVICE_STATUS_FUNC func);
typedef int    (_stdcall*UnregisterDeviceStatusCallBack)(DEVICE_STATUS_FUNC func);
typedef int    (_stdcall*RegisterTouchInfoCallBack)(TOUCH_INFO_FUNC func);
typedef int    (_stdcall*UnregisterTouchInfoCallBack)(TOUCH_INFO_FUNC func);


GetErrorMessage geterrormsg = NULL;
GetDeviceInfo getdevInfo = NULL;
GetDeviceStatus getdevstatus = NULL;
RegisterDeviceStatusCallBack registerdevicestatuscallback = NULL;
UnregisterDeviceStatusCallBack unregisterdevicestatuscallback = NULL;
RegisterTouchInfoCallBack registertouchinfocallback = NULL;
UnregisterTouchInfoCallBack unregistertouchinfocallback = NULL;

	

int main()
{
	HMODULE hModule = LoadLibrary(" BoardSign.dll ");
	if (hModule == NULL) {
		printf("LoadLibrary() failed, error: %d\n", GetLastError());
		return -1;
	}

	geterrormsg = (GetErrorMessage)GetProcAddress(hDll, "GetErrorMessage");
	getdevInfo = (GetDeviceInfo)GetProcAddress(hDll, "GetDeviceInfo");
	getdevstatus = (GetDeviceStatus)GetProcAddress(hDll, "GetDeviceStatus");
	registerdevicestatuscallback = (RegisterDeviceStatusCallBack)GetProcAddress(hDll, "RegisterDeviceStatusCallBack");
	unregisterdevicestatuscallback = (UnregisterDeviceStatusCallBack)GetProcAddress(hDll, "UnregisterDeviceStatusCallBack");
	registertouchinfocallback = (RegisterTouchInfoCallBack)GetProcAddress(hDll, "RegisterTouchInfoCallBack");
	unregistertouchinfocallback = (UnregisterTouchInfoCallBack)GetProcAddress(hDll, "UnregisterTouchInfoCallBack");

	if (geterrormsg == NULL)
	{
		MessageBox(NULL,_T("Load Proc Address GetErrorMessage failed!"), NULL, MB_OK);
		return false;
	}
	if (getdevInfo == NULL)
	{
		MessageBox(NULL,_T("Load Proc Address GetDeviceInfo failed!"), NULL, MB_OK);
		return false;
	}
	if (getdevstatus == NULL)
	{
		MessageBox(NULL,_T("Load Proc Address GetDeviceStatus failed!"), NULL, MB_OK);
		return false;
	}
	if (registerdevicestatuscallback == NULL)
	{
		MessageBox(NULL,_T("Load Proc Address RegisterDeviceStatusCallBack failed!"), NULL, MB_OK);
		return false;
	}
	if (unregisterdevicestatuscallback == NULL)
	{
		MessageBox(NULL,_T("Load Proc Address UnregisterDeviceStatusCallBack failed!"), NULL, MB_OK);
		return false;
	}
	if (registertouchinfocallback == NULL)
	{
		MessageBox(NULL,_T("Load Proc Address RegisterTouchInfoCallBack failed!"), NULL, MB_OK);
		return false;
	}
	if (unregistertouchinfocallback == NULL)
	{
		MessageBox(NULL,_T("Load Proc Address UnregisterTouchInfoCallBack failed!"), NULL, MB_OK);
		return false;
	}

	//An example of a device state call.
	DEVICE_STATUS_FUNC lpfun = (DEVICE_STATUS_FUNC)device_status_func;
	int status = appRegisterDeviceStatusCallBack(lpfun);
	if (status == 0)
	{
		MessageBox(NULL,_T("call Proc Address device_status_func success!"), NULL, MB_OK);			
	}
	else
	{		
		MessageBox(NULL,_T("Load Proc Address device_status_func failed!"), NULL, MB_OK);
	}

	//Gets an example of a coordinate data call.
	TOUCH_INFO_FUNC lpfun = (TOUCH_INFO_FUNC)touch_info_fun;
	int status = appRegisterTouchInfoCallBack(lpfun);
	if (status == 0)
	{
		MessageBox(NULL,_T("call Proc Address touch_info_fun success!"), NULL, MB_OK);				
	}
	else
	{		
		MessageBox(NULL,_T("Load Proc Address touch_info_fun failed!"), NULL, MB_OK);
	}	


	return 0;
}


int CALLBACK touch_info_fun(TOUCH_INFO info)
{

	//add the data processing code.
	
	return 1;
}

int CALLBACK device_status_func(int status)
{

	//add the data processing code.
	
	return 1;
}
